IntRange (API documentation of hlt.language packages)
Date: 2013-01-30

hlt.language.design.backend

## Class IntRange

- java.lang.Object
- - hlt.language.design.backend.IntRange

- All Implemented Interfaces:
    Container, Indexable, IndexableContainer, Iteratable, Lockable, RuntimeObject

      public class IntRange
      extends java.lang.Object
      implements RuntimeObject, IndexableContainer, Lockable

  This denotes an integer range at runtime.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `IntRange()`
    `IntRange(int lo, int hi)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `IntIterator` | `backwardIntIterator()`
    `java.util.Iterator` | `backwardIterator()`
    `DoubleIterator` | `backwardRealIterator()`
    `boolean` | `contains(double element)`
    `boolean` | `contains(int element)`
    `boolean` | `contains(java.lang.Object element)`
    `boolean` | `equals(java.lang.Object object)` Returns `true` when this range is equal (as a set) to the specified object,
    `boolean` | `equals(java.lang.Object object, int[] permutation)` Returns `true` when this range is equal (as a set) to the specified object, with a side-effect on the specified array of ints that will contain the index permutation when the sets are found to be equal.
    `int` | `getIndex(double x)`
    `int` | `getIndex(int i)`
    `int` | `getIndex(java.lang.Object o)`
    `IntIterator` | `indexIterator()`
    `IntIterator` | `intIterator()`
    `IntIterator` | `intIterator(boolean ordered)`
    `boolean` | `isEmpty()`
    `boolean` | `isLocked()`
    `java.util.Iterator` | `iterator()`
    `java.util.Iterator` | `iterator(boolean ordered)`
    `int` | `lb()`
    `void` | `lock()`
    `DoubleIterator` | `realIterator()`
    `DoubleIterator` | `realIterator(boolean ordered)`
    `int` | `size()`
    `IntSet` | `toIntSet()`
    `java.lang.String` | `toString()`
    `int` | `ub()`
    `void` | `unlock()`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### IntRange

          public IntRange()

    - #### IntRange

          public IntRange(int lo,
                  int hi)

  - ### Method Detail

    - #### isEmpty

          public final boolean isEmpty()

      Specified by:
        `isEmpty` in interface `Container`

    - #### contains

          public final boolean contains(int element)

      Specified by:
        `contains` in interface `Container`

    - #### contains

          public final boolean contains(double element)

      Specified by:
        `contains` in interface `Container`

    - #### contains

          public final boolean contains(java.lang.Object element)

      Specified by:
        `contains` in interface `Container`

    - #### lb

          public final int lb()

    - #### ub

          public final int ub()

    - #### size

          public final int size()

      Specified by:
        `size` in interface `Indexable`

    - #### getIndex

          public final int getIndex(int i)

      Specified by:
        `getIndex` in interface `Indexable`

    - #### getIndex

          public final int getIndex(double x)

      Specified by:
        `getIndex` in interface `Indexable`

    - #### getIndex

          public final int getIndex(java.lang.Object o)

      Specified by:
        `getIndex` in interface `Indexable`

    - #### lock

          public final void lock()

      Specified by:
        `lock` in interface `Lockable`

    - #### unlock

          public final void unlock()

      Specified by:
        `unlock` in interface `Lockable`

    - #### isLocked

          public final boolean isLocked()

      Specified by:
        `isLocked` in interface `Lockable`

    - #### toIntSet

          public final IntSet toIntSet()

    - #### intIterator

          public final IntIterator intIterator(boolean ordered)

      Specified by:
        `intIterator` in interface `Iteratable`

    - #### intIterator

          public final IntIterator intIterator()

      Specified by:
        `intIterator` in interface `Iteratable`

    - #### realIterator

          public final DoubleIterator realIterator(boolean ordered)

      Specified by:
        `realIterator` in interface `Iteratable`

    - #### realIterator

          public final DoubleIterator realIterator()

      Specified by:
        `realIterator` in interface `Iteratable`

    - #### iterator

          public final java.util.Iterator iterator(boolean ordered)

      Specified by:
        `iterator` in interface `Iteratable`

    - #### iterator

          public final java.util.Iterator iterator()

      Specified by:
        `iterator` in interface `Iteratable`

    - #### backwardIntIterator

          public final IntIterator backwardIntIterator()

      Specified by:
        `backwardIntIterator` in interface `Iteratable`

    - #### backwardRealIterator

          public final DoubleIterator backwardRealIterator()

      Specified by:
        `backwardRealIterator` in interface `Iteratable`

    - #### backwardIterator

          public final java.util.Iterator backwardIterator()

      Specified by:
        `backwardIterator` in interface `Iteratable`

    - #### indexIterator

          public final IntIterator indexIterator()

      Specified by:
        `indexIterator` in interface `Indexable`

    - #### equals

          public final boolean equals(java.lang.Object object)

      Returns `true` when this range is equal (as a set) to the specified object,
      Overrides:
        `equals` in class `java.lang.Object`

    - #### equals

          public final boolean equals(java.lang.Object object,
                       int[] permutation)

      Returns `true` when this range is equal (as a set) to the specified object, with a side-effect on the specified array of ints that will contain the index permutation when the sets are found to be equal.
      Specified by:
        `equals` in interface `Indexable`

    - #### toString

          public final java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`